# coding: utf-8

"""
    LUXSCI

    For a technical overview, see [LuxSci API Mechanics Guide](/rest-api/mechanics.html)  Return to [The API Guide](/rest-api.html)  # noqa: E501

    OpenAPI spec version: v2023.17.6
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DomainReport(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'accept_mail': 'str',
        'catchall_action': 'str',
        'catchall_data': 'str',
        'catchall_on': 'str',
        'is_enabled': 'str'
    }

    attribute_map = {
        'accept_mail': 'accept_mail',
        'catchall_action': 'catchall_action',
        'catchall_data': 'catchall_data',
        'catchall_on': 'catchall_on',
        'is_enabled': 'is_enabled'
    }

    def __init__(self, accept_mail=None, catchall_action=None, catchall_data=None, catchall_on=None, is_enabled=None):  # noqa: E501
        """DomainReport - a model defined in Swagger"""  # noqa: E501
        self._accept_mail = None
        self._catchall_action = None
        self._catchall_data = None
        self._catchall_on = None
        self._is_enabled = None
        self.discriminator = None
        if accept_mail is not None:
            self.accept_mail = accept_mail
        if catchall_action is not None:
            self.catchall_action = catchall_action
        if catchall_data is not None:
            self.catchall_data = catchall_data
        if catchall_on is not None:
            self.catchall_on = catchall_on
        if is_enabled is not None:
            self.is_enabled = is_enabled

    @property
    def accept_mail(self):
        """Gets the accept_mail of this DomainReport.  # noqa: E501

        Optional: False (“0”). True values (e.g. “1”) will result in the domain being able to accept new emails (once validated by updating MX or A records).  Note that if “is_enabled” is false, then the domain will not accept email, even if this setting is true.  This setting will not be changed if you omit this keyword from your request.  # noqa: E501

        :return: The accept_mail of this DomainReport.  # noqa: E501
        :rtype: str
        """
        return self._accept_mail

    @accept_mail.setter
    def accept_mail(self, accept_mail):
        """Sets the accept_mail of this DomainReport.

        Optional: False (“0”). True values (e.g. “1”) will result in the domain being able to accept new emails (once validated by updating MX or A records).  Note that if “is_enabled” is false, then the domain will not accept email, even if this setting is true.  This setting will not be changed if you omit this keyword from your request.  # noqa: E501

        :param accept_mail: The accept_mail of this DomainReport.  # noqa: E501
        :type: str
        """

        self._accept_mail = accept_mail

    @property
    def catchall_action(self):
        """Gets the catchall_action of this DomainReport.  # noqa: E501

        Can be one of: - “email” – to forward email messages - “delete” – to delete email message - “bounce” – to bounce back email messages with a custom message.  This field is required if catchall_on is true and ignored otherwise.  # noqa: E501

        :return: The catchall_action of this DomainReport.  # noqa: E501
        :rtype: str
        """
        return self._catchall_action

    @catchall_action.setter
    def catchall_action(self, catchall_action):
        """Sets the catchall_action of this DomainReport.

        Can be one of: - “email” – to forward email messages - “delete” – to delete email message - “bounce” – to bounce back email messages with a custom message.  This field is required if catchall_on is true and ignored otherwise.  # noqa: E501

        :param catchall_action: The catchall_action of this DomainReport.  # noqa: E501
        :type: str
        """
        allowed_values = ["email", "delete", "bounce"]  # noqa: E501
        if catchall_action not in allowed_values:
            raise ValueError(
                "Invalid value for `catchall_action` ({0}), must be one of {1}"  # noqa: E501
                .format(catchall_action, allowed_values)
            )

        self._catchall_action = catchall_action

    @property
    def catchall_data(self):
        """Gets the catchall_data of this DomainReport.  # noqa: E501

        This contains data for your “catchall_action”: - “email” – Is a comma-delimited list of email addresses to forward email to. This list will be validted. - “bounce” – is a short plain text message (50 characters or less) to explain why the bounce is happening. - “delete” – “catchall_data” ignored.  This field is required if catchall_on is true and catchall_action is not “delete”, and ignored otherwise.  # noqa: E501

        :return: The catchall_data of this DomainReport.  # noqa: E501
        :rtype: str
        """
        return self._catchall_data

    @catchall_data.setter
    def catchall_data(self, catchall_data):
        """Sets the catchall_data of this DomainReport.

        This contains data for your “catchall_action”: - “email” – Is a comma-delimited list of email addresses to forward email to. This list will be validted. - “bounce” – is a short plain text message (50 characters or less) to explain why the bounce is happening. - “delete” – “catchall_data” ignored.  This field is required if catchall_on is true and catchall_action is not “delete”, and ignored otherwise.  # noqa: E501

        :param catchall_data: The catchall_data of this DomainReport.  # noqa: E501
        :type: str
        """
        allowed_values = ["email", "bounce", "delete"]  # noqa: E501
        if catchall_data not in allowed_values:
            raise ValueError(
                "Invalid value for `catchall_data` ({0}), must be one of {1}"  # noqa: E501
                .format(catchall_data, allowed_values)
            )

        self._catchall_data = catchall_data

    @property
    def catchall_on(self):
        """Gets the catchall_on of this DomainReport.  # noqa: E501

        Optional: False (e.g. “0”). True (e.g. “1”). If enabled, then the domain-wide email catchall alias will be turned on. We do not recommend that these be used in general ... as they are magnets for inbound spam.  If enabled, then the other catchall action parameters are required.  Domain catchall settings will not be changed if you omit this keyword from your request.  # noqa: E501

        :return: The catchall_on of this DomainReport.  # noqa: E501
        :rtype: str
        """
        return self._catchall_on

    @catchall_on.setter
    def catchall_on(self, catchall_on):
        """Sets the catchall_on of this DomainReport.

        Optional: False (e.g. “0”). True (e.g. “1”). If enabled, then the domain-wide email catchall alias will be turned on. We do not recommend that these be used in general ... as they are magnets for inbound spam.  If enabled, then the other catchall action parameters are required.  Domain catchall settings will not be changed if you omit this keyword from your request.  # noqa: E501

        :param catchall_on: The catchall_on of this DomainReport.  # noqa: E501
        :type: str
        """

        self._catchall_on = catchall_on

    @property
    def is_enabled(self):
        """Gets the is_enabled of this DomainReport.  # noqa: E501

        Optional: False (“0”). True values (e.g. “1”) will result in the domain globally enabled for use (e.g. email, users, etc.). This is the big “domain on/off” switch.  This setting will not be changed if you omit this keyword from your request.  # noqa: E501

        :return: The is_enabled of this DomainReport.  # noqa: E501
        :rtype: str
        """
        return self._is_enabled

    @is_enabled.setter
    def is_enabled(self, is_enabled):
        """Sets the is_enabled of this DomainReport.

        Optional: False (“0”). True values (e.g. “1”) will result in the domain globally enabled for use (e.g. email, users, etc.). This is the big “domain on/off” switch.  This setting will not be changed if you omit this keyword from your request.  # noqa: E501

        :param is_enabled: The is_enabled of this DomainReport.  # noqa: E501
        :type: str
        """

        self._is_enabled = is_enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DomainReport, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DomainReport):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
