# coding: utf-8

"""
    LUXSCI

    For a technical overview, see [LuxSci API Mechanics Guide](/rest-api/mechanics.html)  Return to [The API Guide](/rest-api.html)  # noqa: E501

    OpenAPI spec version: v2024.2.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class EmailForwardingBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'enabled': 'str',
        'deliver': 'str',
        'leave_local': 'str',
        'forward_to': 'str',
        'deny_message': 'str'
    }

    attribute_map = {
        'enabled': 'enabled',
        'deliver': 'deliver',
        'leave_local': 'leave_local',
        'forward_to': 'forward_to',
        'deny_message': 'deny_message'
    }

    def __init__(self, enabled=None, deliver=None, leave_local=None, forward_to=None, deny_message=None):  # noqa: E501
        """EmailForwardingBody - a model defined in Swagger"""  # noqa: E501
        self._enabled = None
        self._deliver = None
        self._leave_local = None
        self._forward_to = None
        self._deny_message = None
        self.discriminator = None
        self.enabled = enabled
        self.deliver = deliver
        if leave_local is not None:
            self.leave_local = leave_local
        self.forward_to = forward_to
        self.deny_message = deny_message

    @property
    def enabled(self):
        """Gets the enabled of this EmailForwardingBody.  # noqa: E501

        Required. Specify “0” to disable forwarding; non-zero to enable.  # noqa: E501

        :return: The enabled of this EmailForwardingBody.  # noqa: E501
        :rtype: str
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this EmailForwardingBody.

        Required. Specify “0” to disable forwarding; non-zero to enable.  # noqa: E501

        :param enabled: The enabled of this EmailForwardingBody.  # noqa: E501
        :type: str
        """
        if enabled is None:
            raise ValueError("Invalid value for `enabled`, must not be `None`")  # noqa: E501

        self._enabled = enabled

    @property
    def deliver(self):
        """Gets the deliver of this EmailForwardingBody.  # noqa: E501

        Required. Specify what should happen to email to this user (if enabled): • “forward” - forward to 1+ email addresses • “delete” - delete all email • “deny” - deny all email with a custom message. Note that delete and deny will apply to all messages and all other custom email filters will be skipped. The forward delivery action will forward email and all other custom email filters, including this forwarding rule, will apply in the usual order.  # noqa: E501

        :return: The deliver of this EmailForwardingBody.  # noqa: E501
        :rtype: str
        """
        return self._deliver

    @deliver.setter
    def deliver(self, deliver):
        """Sets the deliver of this EmailForwardingBody.

        Required. Specify what should happen to email to this user (if enabled): • “forward” - forward to 1+ email addresses • “delete” - delete all email • “deny” - deny all email with a custom message. Note that delete and deny will apply to all messages and all other custom email filters will be skipped. The forward delivery action will forward email and all other custom email filters, including this forwarding rule, will apply in the usual order.  # noqa: E501

        :param deliver: The deliver of this EmailForwardingBody.  # noqa: E501
        :type: str
        """
        if deliver is None:
            raise ValueError("Invalid value for `deliver`, must not be `None`")  # noqa: E501

        self._deliver = deliver

    @property
    def leave_local(self):
        """Gets the leave_local of this EmailForwardingBody.  # noqa: E501

        Optional. For “deliver=forward” cases, specify non-zero if you would like copies of the forwarded email to continue on and pass through the rest of your email filters for possible ultimate delivery to the INBOX. E.g. this is a “not final” forwarding rule. If omitted, leave local will be “off”.  # noqa: E501

        :return: The leave_local of this EmailForwardingBody.  # noqa: E501
        :rtype: str
        """
        return self._leave_local

    @leave_local.setter
    def leave_local(self, leave_local):
        """Sets the leave_local of this EmailForwardingBody.

        Optional. For “deliver=forward” cases, specify non-zero if you would like copies of the forwarded email to continue on and pass through the rest of your email filters for possible ultimate delivery to the INBOX. E.g. this is a “not final” forwarding rule. If omitted, leave local will be “off”.  # noqa: E501

        :param leave_local: The leave_local of this EmailForwardingBody.  # noqa: E501
        :type: str
        """

        self._leave_local = leave_local

    @property
    def forward_to(self):
        """Gets the forward_to of this EmailForwardingBody.  # noqa: E501

        Required for “deliver=forward”. Specify a comma-delimited list of email addresses to which inbound email messages should be forwarded. There is a maximum number of recipients that can be specified (this limit is accountdependent).  # noqa: E501

        :return: The forward_to of this EmailForwardingBody.  # noqa: E501
        :rtype: str
        """
        return self._forward_to

    @forward_to.setter
    def forward_to(self, forward_to):
        """Sets the forward_to of this EmailForwardingBody.

        Required for “deliver=forward”. Specify a comma-delimited list of email addresses to which inbound email messages should be forwarded. There is a maximum number of recipients that can be specified (this limit is accountdependent).  # noqa: E501

        :param forward_to: The forward_to of this EmailForwardingBody.  # noqa: E501
        :type: str
        """
        if forward_to is None:
            raise ValueError("Invalid value for `forward_to`, must not be `None`")  # noqa: E501

        self._forward_to = forward_to

    @property
    def deny_message(self):
        """Gets the deny_message of this EmailForwardingBody.  # noqa: E501

        Required for “deliver=deny”. Specify a short message to return when messages are blocked. Note that this message must be less than 50 characters, contain only latin1 characters and should omit special characters. The message will beautomatically modified to meet these criteria.  # noqa: E501

        :return: The deny_message of this EmailForwardingBody.  # noqa: E501
        :rtype: str
        """
        return self._deny_message

    @deny_message.setter
    def deny_message(self, deny_message):
        """Sets the deny_message of this EmailForwardingBody.

        Required for “deliver=deny”. Specify a short message to return when messages are blocked. Note that this message must be less than 50 characters, contain only latin1 characters and should omit special characters. The message will beautomatically modified to meet these criteria.  # noqa: E501

        :param deny_message: The deny_message of this EmailForwardingBody.  # noqa: E501
        :type: str
        """
        if deny_message is None:
            raise ValueError("Invalid value for `deny_message`, must not be `None`")  # noqa: E501

        self._deny_message = deny_message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EmailForwardingBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EmailForwardingBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
